#import "BatchViewDataSource.h"
#import "Batch.h"

@implementation BatchViewDataSource

- (BatchViewDataSource *)initWithRequest:(NSFetchRequest *)request andContext:(NSManagedObjectContext *)context {
    self = [super init];
    self.fetchedResultsController = [[NSFetchedResultsController alloc] initWithFetchRequest:request managedObjectContext:context sectionNameKeyPath:nil cacheName:nil];
    return self;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return [[self.fetchedResultsController sections] count];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    id <NSFetchedResultsSectionInfo> sectionInfo = [[self.fetchedResultsController sections] objectAtIndex:section];
    return [sectionInfo numberOfObjects];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSString *cellIdentifier = @"BatchCell";

    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier forIndexPath:indexPath];

    Batch *batch = [self.fetchedResultsController objectAtIndexPath:indexPath];
    cell.textLabel.text = batch.name;

    return cell;
}

@end
