#import "HackerSchoolTests.h"
#import "Parser.h"

@implementation HackerSchoolTests

- (void)setUp {
    [super setUp];
    NSString *htmlString = @"<div class=\"two-col\"> <div id=\"utilities\"> <a href=\"/private\"><img alt=\"Small_logo\" src=\"/assets/small_logo-d2f325584ec20eff40c4eee931f82e32.png\"></a> <nav> <ul> <li> <a href=\"/people/271\">Hi, Adam</a> </li> <li> <a href=\"/settings\">Settings</a> </li> <li class=\"last\"> <a href=\"/logout\">Logout</a> </li> </ul> </nav> </div> <div id=\"header\"> </div> <div id=\"content\"> <label for=\"person-filter\" id=\"filter-label\">Filter by:</label> <input autofocus=\"\" id=\"person-filter\"> <ul id=\"batches\"> <li> <h2 style=\"\"> Winter 2013 </h2> <ul id=\"batch7\"> <li class=\"person\"> <a href=\"/people/287\"><img alt=\"Bill_abresch_150\" class=\"profile-image\" src=\"/assets/people/bill_abresch_150-c7be4f1238afb9e5b9eb893c20ae04b5.jpg\"></a> <div class=\"name\"><a href=\"/people/287\">Bill Abresch</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/wija\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:william.abresch@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/36\"><img alt=\"David_albert_150\" class=\"profile-image\" src=\"/assets/people/david_albert_150-78a3bd78fcd02a18fe9e42e976d86403.jpg\"></a> <div class=\"name\"><a href=\"/people/36\">David Albert</a></div> <div class=\"irc\">IRC: davidbalbert</div> <span class=\"skills\">ruby, c, git, vim, yaks</span> <div class=\"icon-links\"> <a href=\"http://github.com/davidbalbert\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/davidbalbert\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:dave@hackerschool.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/272\"><img alt=\"Santiago_albo_150\" class=\"profile-image\" src=\"/assets/people/santiago_albo_150-3d37708232aec05993bb733c75dee18f.jpg\"></a> <div class=\"name\"><a href=\"/people/272\">Santiago Albo</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/santialbo\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/curial\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:santialbo@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/94\"><img alt=\"Zach_allaun_150\" class=\"profile-image\" src=\"/assets/people/zach_allaun_150-47ebe3c440ff71bc6bd0151bb43e2235.jpg\"></a> <div class=\"name\"><a href=\"/people/94\">Zach Allaun</a></div> <div class=\"irc\">IRC: _zach</div> <span class=\"skills\">javascript, python, clojure, ruby, clojurescript, lisp, coffeescript</span> <div class=\"icon-links\"> <a href=\"http://github.com/zachallaun\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/riotonthebay\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:zach@hackerschool.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/279\"><img alt=\"Greg_altman_150\" class=\"profile-image\" src=\"/assets/people/greg_altman_150-5f6634db74bde67275a98c14863e6342.jpg\"></a> <div class=\"name\"><a href=\"/people/279\">Greg Altman</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">javascript, css, html, php, mysql</span> <div class=\"icon-links\"> <a href=\"mailto:g.s.altman@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/53\"><img alt=\"Thomas_ballinger_150\" class=\"profile-image\" src=\"/assets/people/thomas_ballinger_150-ed8e317ede5cda3ef47cbad4629ea3d1.jpg\"></a> <div class=\"name\"><a href=\"/people/53\">Tom Ballinger</a></div> <div class=\"irc\">IRC: ballingt</div> <span class=\"skills\">javascript, python, image processing, signal processing, sound synthesis, music analysis, erlang</span> <div class=\"icon-links\"> <a href=\"http://github.com/thomasballinger\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/ballingt\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:tom@hackerschool.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/269\"><img alt=\"Neha_batra_150\" class=\"profile-image\" src=\"/assets/people/neha_batra_150-645b75c16b908cbc045bde90b8a60928.jpg\"></a> <div class=\"name\"><a href=\"/people/269\">Neha Batra</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">python, matlab, bottle</span> <div class=\"icon-links\"> <a href=\"http://github.com/nehalita\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:nehalita@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/275\"><img alt=\"Alexandre_beaulne_150\" class=\"profile-image\" src=\"/assets/people/alexandre_beaulne_150-6a23ccf9053030aa57c8066c3ac1af05.jpg\"></a> <div class=\"name\"><a href=\"/people/275\">Alexandre Beaulne</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">- Python - Erlang - Math &amp; Stats - Numerical computing</span> <div class=\"icon-links\"> <a href=\"http://github.com/AlexandreBeaulne\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:alexandre.beaulne@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/34\"><img alt=\"Nick_bergson-shilcock_150\" class=\"profile-image\" src=\"/assets/people/nick_bergson-shilcock_150-60d781b2f3aae9ce66835c9549dd5d1f.jpg\"></a> <div class=\"name\"><a href=\"/people/34\">Nick Bergson-Shilcock</a></div> <div class=\"irc\">IRC: nicholasbs</div> <span class=\"skills\">javascript, ruby, vim, computer science theory, functional programming</span> <div class=\"icon-links\"> <a href=\"http://github.com/nicholasbs\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/nicholasbs\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:nick@hackerschool.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/286\"><img alt=\"Be_birchall_150\" class=\"profile-image\" src=\"/assets/people/be_birchall_150-3acd08ac49d84704a85cdc3c1a8c419a.jpg\"></a> <div class=\"name\"><a href=\"/people/286\">Be Birchall</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/bebebebebe\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:bebirchall@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/254\"><img alt=\"Thomas_boyt_150\" class=\"profile-image\" src=\"/assets/people/thomas_boyt_150-280c6c641242338ce81baa75a0950848.jpg\"></a> <div class=\"name\"><a href=\"/people/254\">Thomas Boyt</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">javascript, python, backbone</span> <div class=\"icon-links\"> <a href=\"http://github.com/thomasboyt\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/thomasaboyt\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:me@thomasboyt.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/260\"><img alt=\"David_branner_150\" class=\"profile-image\" src=\"/assets/people/david_branner_150-9afc7cba91bb414590b289b3bb6d4ba6.jpg\"></a> <div class=\"name\"><a href=\"/people/260\">David Branner</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">python, latex, regex</span> <div class=\"icon-links\"> <a href=\"http://github.com/brannerchinese\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:brannerchinese@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/262\"><img alt=\"Richard_burton_150\" class=\"profile-image\" src=\"/assets/people/richard_burton_150-cc9a97916e5e7914c6abb6d5ede1125c.jpg\"></a> <div class=\"name\"><a href=\"/people/262\">Richard Burton</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">rails, Played with: Ruby, Sinatra Working on: Objective-C</span> <div class=\"icon-links\"> <a href=\"http://github.com/richardburton\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/ricburton\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:me@richardjburton.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/288\"><img alt=\"Jin_chung_150\" class=\"profile-image\" src=\"/assets/people/jin_chung_150-126cb2442bc81f0cf1e1db20b3b605ba.jpg\"></a> <div class=\"name\"><a href=\"/people/288\">Jin Chung</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">Java Spring Hibernate</span> <div class=\"icon-links\"> <a href=\"http://github.com/hyojinchung\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:hyojin.chung17@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/192\"><img alt=\"Jennifer_clark_150\" class=\"profile-image\" src=\"/assets/people/jennifer_clark_150-450e51eaf143e303eac09ef497d706d2.jpg\"></a> <div class=\"name\"><a href=\"/people/192\">Jennifer Clark</a></div> <div class=\"irc\">IRC: jac300</div> <span class=\"skills\">objective c, Xcode</span> <div class=\"icon-links\"> <a href=\"http://github.com/jac300\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:jac300@nyu.edu\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/276\"><img alt=\"Nick_collins_150\" class=\"profile-image\" src=\"/assets/people/nick_collins_150-1438650a0dddaab12c39b92c1b83d9c6.jpg\"></a> <div class=\"name\"><a href=\"/people/276\">Nick Collins</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">python, statistics, math, scheme, Machine Learning, racket</span> <div class=\"icon-links\"> <a href=\"http://github.com/ncollins\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/nycgwailou\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:nick@vividx.co.uk\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/291\"><img alt=\"Chris_edgemon_150\" class=\"profile-image\" src=\"/assets/people/chris_edgemon_150-e87ef345532220986bb274de3ea4a077.jpg\"></a> <div class=\"name\"><a href=\"/people/291\">Chris Edgemon</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/chirs\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/chrisedgemon\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:chrisedgemon@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/265\"><img alt=\"Daniel_espeset_150\" class=\"profile-image\" src=\"/assets/people/daniel_espeset_150-69955f5c74b7edb9b5d19ed83eb58ab3.jpg\"></a> <div class=\"name\"><a href=\"/people/265\">Daniel Espeset</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/danielmendel\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/danielespeset\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:daniel@danielespeset.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/266\"><img alt=\"Patrick_estabrook_150\" class=\"profile-image\" src=\"/assets/people/patrick_estabrook_150-4504917ecc0a1d92df4ff2969eabf05a.jpg\"></a> <div class=\"name\"><a href=\"/people/266\">Patrick Estabrook</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">ruby, rails, css, html, Arduino, embedded C, MIPS assembly, MIDI, and circuit design/analysis.  I'm learning JavaScript, and whatever else may be useful (and help make me imminently employable!)</span> <div class=\"icon-links\"> <a href=\"http://github.com/patrickmestabrook\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/pattty_cakes\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:patrick.m.estabrook@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/267\"><img alt=\"Scott_feeney_150\" class=\"profile-image\" src=\"/assets/people/scott_feeney_150-124fefe01f5e1a6f061f0183ba116231.jpg\"></a> <div class=\"name\"><a href=\"/people/267\">Scott Feeney</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">javascript, c, python, php</span> <div class=\"icon-links\"> <a href=\"http://github.com/graue\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/graue\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:scott@scott.mn\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/271\"><img alt=\"Adam_fraser_150\" class=\"profile-image\" src=\"/assets/people/adam_fraser_150-9703323f18b8a6e56aea9c8597173610.jpg\"></a> <div class=\"name\"><a href=\"/people/271\">Adam Fraser</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/codepost\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/adamfraser_\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:adamfraser0@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/259\"><img alt=\"Chuck_ha_150\" class=\"profile-image\" src=\"/assets/people/chuck_ha_150-5c7b57e8f81871c5c9a8725f53f43a19.jpg\"></a> <div class=\"name\"><a href=\"/people/259\">Chuck Ha</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">javascript, git, python, bash, code organization</span> <div class=\"icon-links\"> <a href=\"http://github.com/ggnextmap\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/chuck_ha\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:ha.chuck@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/283\"><img alt=\"Einas_haddad_150\" class=\"profile-image\" src=\"/assets/people/einas_haddad_150-996dd71151535dc1faeae52543867a49.jpg\"></a> <div class=\"name\"><a href=\"/people/283\">Einas Haddad</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/einashaddad\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/einashaddad\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:einas.haddad@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/280\"><img alt=\"Leah_hanson_150\" class=\"profile-image\" src=\"/assets/people/leah_hanson_150-512b01a5fef7da68a0df937b5f2d841a.jpg\"></a> <div class=\"name\"><a href=\"/people/280\">Leah Hanson</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/astrieanna\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:Leah.A.Hanson@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/219\"><img alt=\"Romy_hong_150\" class=\"profile-image\" src=\"/assets/people/romy_hong_150-8a85bdcba5d1d754822991ec61392866.jpg\"></a> <div class=\"name\"><a href=\"/people/219\">Romy Hong</a></div> <div class=\"irc\">IRC: UberNerdGirl</div> <span class=\"skills\">ruby, SQL, sinatra, lisp, photoshop. want to master clojure, and c though., javascript</span> <div class=\"icon-links\"> <a href=\"http://github.com/syntacticsugar\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/RomyOnRuby\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:romy@romyromy.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/270\"><img alt=\"Raul_jara_150\" class=\"profile-image\" src=\"/assets/people/raul_jara_150-a156acf514ca5199ddcc55505d5795d2.jpg\"></a> <div class=\"name\"><a href=\"/people/270\">Raúl Jara</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">javascript, ruby, git, css, java, html5, haskell, objective c, scala, SML, scss</span> <div class=\"icon-links\"> <a href=\"http://github.com/rcjara\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:raul.c.jara@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/258\"><img alt=\"Feivel_jellyfish_150\" class=\"profile-image\" src=\"/assets/people/feivel_jellyfish_150-2e3e62879ac00fa8b098f1ed0d31df50.jpg\"></a> <div class=\"name\"><a href=\"/people/258\">Feivel Jellyfish</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">ruby, git, common lisp, rails, SQL, rspec, haml</span> <div class=\"icon-links\"> <a href=\"http://github.com/gwentacle\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:feivel@sdf.org\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/257\"><img alt=\"Allie_jones_150\" class=\"profile-image\" src=\"/assets/people/allie_jones_150-bdc6aaeb79d71a7e93fa260485be1d51.jpg\"></a> <div class=\"name\"><a href=\"/people/257\">Allie Jones</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/alliejones\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/gredaline\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:allie.jones@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/96\"><img alt=\"Allison_kaptur_150\" class=\"profile-image\" src=\"/assets/people/allison_kaptur_150-f778c7f7d1c2824f03bb028fdcc810a6.jpg\"></a> <div class=\"name\"><a href=\"/people/96\">Allison Kaptur</a></div> <div class=\"irc\">IRC: akaptur</div> <span class=\"skills\">python</span> <div class=\"icon-links\"> <a href=\"http://github.com/akaptur\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/akaptur\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:allison@hackerschool.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/208\"><img alt=\"Margo_kulkarni_150\" class=\"profile-image\" src=\"/assets/people/margo_kulkarni_150-8f3e3e9d1fbf2764736c4b78298e80f6.jpg\"></a> <div class=\"name\"><a href=\"/people/208\">Margo Kulkarni</a></div> <div class=\"irc\">IRC: margoK</div> <span class=\"skills\">python, algorithms, math, sockets</span> <div class=\"icon-links\"> <a href=\"http://github.com/margo-K\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:margo.r.kulkarni@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/293\"><img alt=\"Sasha_laundy_150\" class=\"profile-image\" src=\"/assets/people/sasha_laundy_150-8e860ca57e9ea30a536e9002b77ce993.jpg\"></a> <div class=\"name\"><a href=\"/people/293\">Sasha Laundy</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/sashalaundy\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/sashalaundy\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:sasha.laundy@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/273\"><img alt=\"Lushi_li_150\" class=\"profile-image\" src=\"/assets/people/lushi_li_150-7647a4ebfcc36dff2801bb23b422c5cb.jpg\"></a> <div class=\"name\"><a href=\"/people/273\">Lushi Li</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"mailto:lushili06@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/224\"><img alt=\"Becca_liss_150\" class=\"profile-image\" src=\"/assets/people/becca_liss_150-b2735580db9ef1a27ed230add2f1b288.jpg\"></a> <div class=\"name\"><a href=\"/people/224\">Becca Liss</a></div> <div class=\"irc\">IRC: becca</div> <span class=\"skills\">git, python, technical writing</span> <div class=\"icon-links\"> <a href=\"http://github.com/becdot\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/becdot\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:becca.liss@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/284\"><img alt=\"David_lundgren_150\" class=\"profile-image\" src=\"/assets/people/david_lundgren_150-1540f300d014e3eb4a0ff290bfa549cb.jpg\"></a> <div class=\"name\"><a href=\"/people/284\">David Lundgren</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">git, python, java, natural language processing, Machine Learning, information retrieval</span> <div class=\"icon-links\"> <a href=\"http://github.com/maxlikely\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/davidmlundgren\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:david.m.lundgren+login@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/255\"><img alt=\"Dan_luu_150\" class=\"profile-image\" src=\"/assets/people/dan_luu_150-1fb724f9828a4078bcb81afad56a0299.jpg\"></a> <div class=\"name\"><a href=\"/people/255\">Dan Luu</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/danluu\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:danluu@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/264\"><img alt=\"Marek_majkowski_150\" class=\"profile-image\" src=\"/assets/people/marek_majkowski_150-21e23d08a77006247dba87430647914f.jpg\"></a> <div class=\"name\"><a href=\"/people/264\">Marek Majkowski</a></div> <div class=\"irc\">IRC: majek</div> <span class=\"skills\">javascript, c, git, python, erlang, networking, Security</span> <div class=\"icon-links\"> <a href=\"http://github.com/majek\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/majek04\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:majek04@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/292\"><img alt=\"Sean_mcgovern_150\" class=\"profile-image\" src=\"/assets/people/sean_mcgovern_150-f75c443770b63de697f5eff1c8a8ad0d.jpg\"></a> <div class=\"name\"><a href=\"/people/292\">Sean McGovern</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"mailto:st.mcgovern@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/285\"><img alt=\"Clint_newsom_150\" class=\"profile-image\" src=\"/assets/people/clint_newsom_150-033f63f7e86912c57b3620e38b5b7354.jpg\"></a> <div class=\"name\"><a href=\"/people/285\">Clint Newsom</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">javascript, git, clojure, php, scheme, SML</span> <div class=\"icon-links\"> <a href=\"http://github.com/newsomc\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/clint_newsom\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:hcnewsom@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/29\"><img alt=\"Alan_odonnell_150\" class=\"profile-image\" src=\"/assets/people/alan_odonnell_150-d143d572ae47691677586c9bc9b6364e.jpg\"></a> <div class=\"name\"><a href=\"/people/29\">Alan O'Donnell</a></div> <div class=\"irc\">IRC: happy4crazy</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/happy4crazy\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/happy4crazy\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:alan@hackerschool.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/282\"><img alt=\"Angela_panfil_150\" class=\"profile-image\" src=\"/assets/people/angela_panfil_150-702887092a4df722e8f3260ca2faca74.jpg\"></a> <div class=\"name\"><a href=\"/people/282\">Angela Panfil</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">javascript, vim, css, html, svn, jquery, jmvc</span> <div class=\"icon-links\"> <a href=\"http://github.com/panfia\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/angiepanfil\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:panfia1@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/289\"><img alt=\"Colin_regan_150\" class=\"profile-image\" src=\"/assets/people/colin_regan_150-dafd71504b757af9d5c63d13765f7059.jpg\"></a> <div class=\"name\"><a href=\"/people/289\">Colin Regan</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">git, stata, obj-c</span> <div class=\"icon-links\"> <a href=\"http://github.com/RedCupCorporation\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/khaullen\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:khaullen@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/290\"><img alt=\"Omar_rizwan_150\" class=\"profile-image\" src=\"/assets/people/omar_rizwan_150-533f057fac9dbf596f167043b22a9bd4.jpg\"></a> <div class=\"name\"><a href=\"/people/290\">Omar Rizwan</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/osnr\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/rsnous\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:omar.rizwan@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/274\"><img alt=\"Eric_romano_150\" class=\"profile-image\" src=\"/assets/people/eric_romano_150-e1e291c016dc51d8ddc6e795fee74e99.jpg\"></a> <div class=\"name\"><a href=\"/people/274\">Eric Romano</a></div> <div class=\"irc\">IRC: gelstudios</div> <span class=\"skills\">python, bash, Linux</span> <div class=\"icon-links\"> <a href=\"http://github.com/gelstudios\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/gelstudios\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:gelstudios@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/268\"><img alt=\"Dom_roselli_150\" class=\"profile-image\" src=\"/assets/people/dom_roselli_150-e277f5e213a5426a757200ee549519e7.jpg\"></a> <div class=\"name\"><a href=\"/people/268\">Dom Roselli</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">c, SQL, some Python</span> <div class=\"icon-links\"> <a href=\"mailto:dlp2000@live.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/277\"><img alt=\"Daniel_schobel_150\" class=\"profile-image\" src=\"/assets/people/daniel_schobel_150-622639b0c47300eb1ee107acb94257a8.jpg\"></a> <div class=\"name\"><a href=\"/people/277\">Daniel Schobel</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/dschobel\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/dschobel\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:dschobel@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/278\"><img alt=\"Stacey_sern_150\" class=\"profile-image\" src=\"/assets/people/stacey_sern_150-ef3015166e040127687ae8a71c667595.jpg\"></a> <div class=\"name\"><a href=\"/people/278\">Stacey Sern</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">c, python, c++, java</span> <div class=\"icon-links\"> <a href=\"mailto:staceysern@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/256\"><img alt=\"Russell_smith_150\" class=\"profile-image\" src=\"/assets/people/russell_smith_150-7a440f7e6ebfaff1fbe88166bdec3180.jpg\"></a> <div class=\"name\"><a href=\"/people/256\">Russell Smith</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/qqrs\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/qqrsmith\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:qqrsmith@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/35\"><img alt=\"Sonali_sridhar_150\" class=\"profile-image\" src=\"/assets/people/sonali_sridhar_150-ebc38f8cf2ad53ac5370a6ba6ae46c59.jpg\"></a> <div class=\"name\"><a href=\"/people/35\">Sonali Sridhar</a></div> <div class=\"irc\">IRC: jollysonali</div> <span class=\"skills\">css, html</span> <div class=\"icon-links\"> <a href=\"http://github.com/jollysonali\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/jollysonali\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:sonali@hackerschool.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/263\"><img alt=\"Leocadio_tine_150\" class=\"profile-image\" src=\"/assets/people/leocadio_tine_150-923429ee6fb17f3c292dc1fac8b41347.jpg\"></a> <div class=\"name\"><a href=\"/people/263\">Leocadio Tiné</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">git, java, SQL, ios, Android, Mobile, obj-c, game development</span> <div class=\"icon-links\"> <a href=\"http://github.com/leocadiotine\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/leocadiotine\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:leocadiotine@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/281\"><img alt=\"Nathan_w_brei_150\" class=\"profile-image\" src=\"/assets/people/nathan_w_brei_150-2a3b51927a51a96268eebac0278ad817.jpg\"></a> <div class=\"name\"><a href=\"/people/281\">Nathan W Brei</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">c, matlab, My weapon of choice is Python, though I'm also comfortable with Java, and Scheme. I fell in love with programming in 7th grade with Turbo Pascal, and I've somehow managed to acquaint myself with lots of languages of questionable usefulness.</span> <div class=\"icon-links\"> <a href=\"http://github.com/nathanwbrei\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:n_brei@alum.mit.edu\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/261\"><img alt=\"Jay_weisskopf_150\" class=\"profile-image\" src=\"/assets/people/jay_weisskopf_150-9edfaa68b6847f34387ed5079be0e2e3.jpg\"></a> <div class=\"name\"><a href=\"/people/261\">Jay Weisskopf</a></div> <div class=\"hidden irc\">IRC: </div> <span class=\"skills\">c, python, go, java, Android, golang, OpenGL, git</span> <div class=\"icon-links\"> <a href=\"http://github.com/jayschwa\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/jwskpf\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jay@jayschwa.net\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> </ul> </li> <li> <h2 style=\"\"> Fall 2012 </h2> <ul id=\"batch5\"> <li class=\"person\"> <a href=\"/people/195\"><img alt=\"Hasen_ahmad_150\" class=\"profile-image\" src=\"/assets/people/hasen_ahmad_150-2190b818ce6e2c82053bb709aa9f6baf.jpg\"></a> <div class=\"name\"><a href=\"/people/195\">Hasen Ahmad</a></div> <div class=\"irc\">IRC: DukeofURL</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, c, git, c++, css, html, php, java, Android, web design, animation, drifting</span> <div class=\"icon-links\"> <a href=\"http://github.com/kaizokuace\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/kaizokuace\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:kaizokuace@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/212\"><img alt=\"Senthil_arivudainambi_150\" class=\"profile-image\" src=\"/assets/people/senthil_arivudainambi_150-a26430e6cb7f45967649c0c48cd1a01c.jpg\"></a> <div class=\"name\"><a href=\"/people/212\">Senthil Arivudainambi</a></div> <div class=\"irc\">IRC: sent-hil</div> <div class=\"job\">Freelance</div> <span class=\"skills\">ruby, git, rails, mongodb, goliath/eventmachine, oAuth2, mysql, rspec, api (especially Facebook &amp; Google), Cucumber</span> <div class=\"icon-links\"> <a href=\"http://github.com/sent-hil\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/sent0hil\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:me@sent-hil.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/200\"><img alt=\"Vid_ayer_150\" class=\"profile-image\" src=\"/assets/people/vid_ayer_150-36aecf87dd2cad6c4e3a9d4320f3c9de.jpg\"></a> <div class=\"name\"><a href=\"/people/200\">Vid Ayer</a></div> <div class=\"irc\">IRC: svaksha</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">▪ Bitbucket repo: &lt;https://bitbucket.org/svaksha/&gt; ▪ GSoC Systers Repo: &lt;https://code.launchpad.net/~systers-dev/systers/product-release-systers&gt; and &lt;https://code.launchpad.net/~systers-dev/systers/auto-functional-test&gt;</span> <div class=\"icon-links\"> <a href=\"http://github.com/svaksha\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/svaksha\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:svaksha@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/222\"><img alt=\"Darius_bacon_150\" class=\"profile-image\" src=\"/assets/people/darius_bacon_150-04ea69d7ccb1d73a04184343cdc2c860.jpg\"></a> <div class=\"name\"><a href=\"/people/222\">Darius Bacon</a></div> <div class=\"irc\">IRC: darius</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, c, python, functional programming, scheme, prolog, lisp, toy programming language design and implementation, editing code for clarity, Forth, ML, statistical natural language processing, capability security</span> <div class=\"icon-links\"> <a href=\"http://github.com/darius\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/abecedarius\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:darius@wry.me\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/198\"><img alt=\"Edith_beer_150\" class=\"profile-image\" src=\"/assets/people/edith_beer_150-55983e893a765b4eb658a8b9bd2541e8.jpg\"></a> <div class=\"name\"><a href=\"/people/198\">Edith Beer</a></div> <div class=\"irc\">IRC: ediebeer</div> <div class=\"job\"><a href=\"http://oskarth.com/\">Freelancer</a></div> <span class=\"skills\">c, python, java, database architecture</span> <div class=\"icon-links\"> <a href=\"http://github.com/ebeer\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/ediebeer\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:ediebeer@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/205\"><img alt=\"Jamie_brandon_150\" class=\"profile-image\" src=\"/assets/people/jamie_brandon_150-b5a47ccab846d0623ac4512a0a94dc36.jpg\"></a> <div class=\"name\"><a href=\"/people/205\">Jamie Brandon</a></div> <div class=\"irc\">IRC: jamii</div> <div class=\"job\"><a href=\"http://scattered-thoughts.net/about\">Freelancer (Scattered Thoughts Ltd)</a></div> <span class=\"skills\">algorithms, distributed systems, p2p</span> <div class=\"icon-links\"> <a href=\"http://github.com/jamii\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:jamie@scattered-thoughts.net\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/211\"><img alt=\"Angus_burton_150\" class=\"profile-image\" src=\"/assets/people/angus_burton_150-0695063a01619878e622fb3a8db78f31.jpg\"></a> <div class=\"name\"><a href=\"/people/211\">Angus Burton</a></div> <div class=\"irc\">IRC: angusb</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">git, python, django, matlab, SQL, clojure, C/C++, basic machine learning</span> <div class=\"icon-links\"> <a href=\"http://github.com/angusb\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/angusnb\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:angusb@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/181\"><img alt=\"Betsy_cannon_150\" class=\"profile-image\" src=\"/assets/people/betsy_cannon_150-7aa791d223a8d90686ecdf87780526fd.jpg\"></a> <div class=\"name\"><a href=\"/people/181\">Betsy Cannon</a></div> <div class=\"irc\">IRC: forklady42</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/forklady42\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:cannon.bea@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/209\"><img alt=\"Ruby_childs_150\" class=\"profile-image\" src=\"/assets/people/ruby_childs_150-cb9410d83ab21d5c09b56e823a012646.jpg\"></a> <div class=\"name\"><a href=\"/people/209\">Ruby Childs</a></div> <div class=\"irc\">IRC: redrubia</div> <div class=\"job\">N/A</div> <span class=\"skills\">c++, java, eclipse, prolog, Machine Learning, Image Processing and Analysis, RobotC, some OpenGL, Graphics theory, Algorithmic theory, python, Weka user, Computer Vision and Art classification.  Learning OpenCV, OpenFrameworks and Processing in my spare time.</span> <div class=\"icon-links\"> <a href=\"http://github.com/rubychilds\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/RubyChilds\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:ruby.childs1@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/207\"><img alt=\"Alejandro_ciniglio_150\" class=\"profile-image\" src=\"/assets/people/alejandro_ciniglio_150-5c445694fe45fff1c8edda5e1d66add3.jpg\"></a> <div class=\"name\"><a href=\"/people/207\">Alejandro Ciniglio</a></div> <div class=\"irc\">IRC: alejandro</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">ruby, git, rails, emacs, c, javascript, go, rspec, ror, systems, golang</span> <div class=\"icon-links\"> <a href=\"http://github.com/ciniglio\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/skiaec04\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:alejandrociniglio@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/203\"><img alt=\"Pieter_de_vlieger_150\" class=\"profile-image\" src=\"/assets/people/pieter_de_vlieger_150-828e2c8cdb17cc98122dd9e685f11a57.jpg\"></a> <div class=\"name\"><a href=\"/people/203\">Pieter De Vlieger</a></div> <div class=\"irc\">IRC: pieterdevlieger</div> <div class=\"job\"><a href=\"http://none\">none</a></div> <span class=\"skills\">git, matlab, econometrics and statistics, stata, languages, diving into {python}</span> <div class=\"icon-links\"> <a href=\"http://github.com/uctpphd\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:pieterdevlieger@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/179\"><img alt=\"Zach_dexter_150\" class=\"profile-image\" src=\"/assets/people/zach_dexter_150-39eae595c1b5af6c12591eaa89f679eb.jpg\"></a> <div class=\"name\"><a href=\"/people/179\">Zach Dexter</a></div> <div class=\"irc\">IRC: zdexter</div> <div class=\"job\"><a href=\"http://tutorspree.com\">tutorspree</a></div> <span class=\"skills\">python, html, javascript coffeescript, git, vim, django, css, socketstream</span> <div class=\"icon-links\"> <a href=\"http://github.com/zdexter\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/zachdex\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:zach.dexter@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/204\"><img alt=\"Leo_franchi_150\" class=\"profile-image\" src=\"/assets/people/leo_franchi_150-694dd79175261cc3b7ce9564ac68f62e.jpg\"></a> <div class=\"name\"><a href=\"/people/204\">Leo Franchi</a></div> <div class=\"irc\">IRC: lfranchi</div> <div class=\"job\"><a href=\"http://www.humbughq.com\">Humbug, Inc</a></div> <span class=\"skills\">javascript, python, c++, cocoa, Qt, objective-c, clojure, git</span> <div class=\"icon-links\"> <a href=\"http://github.com/lfranchi\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/lfranchi\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:lfranchi@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/197\"><img alt=\"Chad_jablonski_150\" class=\"profile-image\" src=\"/assets/people/chad_jablonski_150-84d7dc75a39d0c7a4cd86fe933cea63c.jpg\"></a> <div class=\"name\"><a href=\"/people/197\">Chad Jablonski</a></div> <div class=\"irc\">IRC: cjab</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/cjab\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:chad.jablonski@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/193\"><img alt=\"Blake_johnson_150\" class=\"profile-image\" src=\"/assets/people/blake_johnson_150-5f895444845be7ed94eec00a81120845.jpg\"></a> <div class=\"name\"><a href=\"/people/193\">Blake Johnson</a></div> <div class=\"irc\">IRC: BlakeJohnson</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, ruby, git, backbone.js, mysql, mocha, AWS, ruby on rails, chef, C(basic), mongo(basic), devops, resque, monit, m/monit, rspec</span> <div class=\"icon-links\"> <a href=\"http://github.com/blake41\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/blake41\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:blake41@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/221\"><img alt=\"Dwayne_jones_150\" class=\"profile-image\" src=\"/assets/people/dwayne_jones_150-5ba37aabebe64fdb17e3f5955a2591fd.jpg\"></a> <div class=\"name\"><a href=\"/people/221\">Dwayne Jones</a></div> <div class=\"irc\">IRC: Dwaynekj</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, Arduino, Physical Computing, Creative Coding, Web, Mobile, javascript</span> <div class=\"icon-links\"> <a href=\"http://github.com/Dwaynekj\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/senojeyawd\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:Dwaynekj@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/182\"><img alt=\"Ryan_koven_150\" class=\"profile-image\" src=\"/assets/people/ryan_koven_150-cbd304779682bc6b3e929a993a258f3b.jpg\"></a> <div class=\"name\"><a href=\"/people/182\">Ryan Koven</a></div> <div class=\"irc\">IRC: ryankoven</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/celeritas17\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:celeritas@ucla.edu\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/206\"><img alt=\"Ted_lee_150\" class=\"profile-image\" src=\"/assets/people/ted_lee_150-64e8379de4b5d3b381fc654aaafb9bd9.jpg\"></a> <div class=\"name\"><a href=\"/people/206\">Ted Lee</a></div> <div class=\"irc\">IRC: TedLee</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, git, python, statistics, rails, sinatra, AWS, R, datamapper, postgres, data viz, data mining, heroku, front end, Machine Learning</span> <div class=\"icon-links\"> <a href=\"http://github.com/TedLee\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/TedLee\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:Ted@TedLee.me\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/201\"><img alt=\"Sandra_lombardi_150\" class=\"profile-image\" src=\"/assets/people/sandra_lombardi_150-c92af340c8a0c0882ebf50bde5a1a2ce.jpg\"></a> <div class=\"name\"><a href=\"/people/201\">Sandra Lombardi</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job\"><a href=\"http://www.wolterskluwer.com/Pages/Home.aspx\">Wolters Kluwer (USA)</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/redWallaroo\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/radwallaroo\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:sandra.f.lombardi@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/186\"><img alt=\"Corey_lynch_150\" class=\"profile-image\" src=\"/assets/people/corey_lynch_150-2141cbb0be32fb71b528a0c59fcd7b42.jpg\"></a> <div class=\"name\"><a href=\"/people/186\">Corey Lynch</a></div> <div class=\"irc\">IRC: clynch</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">c, python, numpy, pandas, joblib., c++, cython, git, NLP, Machine Learning, sklearn, matplotlib</span> <div class=\"icon-links\"> <a href=\"http://github.com/coreylynch\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/coreylynch\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:coreylynch9@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/50\"><img alt=\"Myf_ma_150\" class=\"profile-image\" src=\"/assets/people/myf_ma_150-7330ccb556706ae9fb753be1b8df91e2.jpg\"></a> <div class=\"name\"><a href=\"/people/50\">Myf Ma</a></div> <div class=\"irc\">IRC: myf</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/myf\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/zoon_politikon\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:myf@worldtalks.org\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/111\"><img alt=\"Aria_moraine_150\" class=\"profile-image\" src=\"/assets/people/aria_moraine_150-72d1bfad23931d6be6299cb3848824ab.jpg\"></a> <div class=\"name\"><a href=\"/people/111\">Aria Moraine</a></div> <div class=\"irc\">IRC: ariam</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, django., javascript, java, Android</span> <div class=\"icon-links\"> <a href=\"http://github.com/ariamoraine\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/amoraine\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:ariamoraine@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/184\"><img alt=\"Paul_nichols_150\" class=\"profile-image\" src=\"/assets/people/paul_nichols_150-ffdbfa5741c36f774de67ded2822fa88.jpg\"></a> <div class=\"name\"><a href=\"/people/184\">Paul Nichols</a></div> <div class=\"irc\">IRC: paulnichols</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, python, django, flask, HTML/CSS</span> <div class=\"icon-links\"> <a href=\"http://github.com/pnichols104\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:pnichols104@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/191\"><img alt=\"Vincent_ohprecio_150\" class=\"profile-image\" src=\"/assets/people/vincent_ohprecio_150-786718cc546fe0540cb49d91baf5d10e.jpg\"></a> <div class=\"name\"><a href=\"/people/191\">Vincent Ohprecio</a></div> <div class=\"irc\">IRC: antigen</div> <div class=\"job\">Freelance</div> <span class=\"skills\">ruby, python, Network Security, Application Security Frameworks, Ethical Hacking, Computer Crime Investigation, Machine Learning, data mining, Data Visualization</span> <div class=\"icon-links\"> <a href=\"http://github.com/bigsnarfdude\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/bigsnarfdude\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:ohprecio@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/183\"><img alt=\"Nimrod_omer_150\" class=\"profile-image\" src=\"/assets/people/nimrod_omer_150-a79c978042f061509241bc0f857415f6.jpg\"></a> <div class=\"name\"><a href=\"/people/183\">Nimrod Omer</a></div> <div class=\"irc\">IRC: DeadDork</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">git, bash, SQL, perl, R, mercurial, latex, Linux, c, css, html, Mac OS X, VBA, mysql, windows, some javascript, svn, Gawk, some Python, some BASIC, some Java, Microsoft SQL Server, Sybase Adapative Server Enterprise, Open/LibreOffice, Microsoft Office, Google Drive, Unix Core Utilities</span> <div class=\"icon-links\"> <a href=\"http://github.com/DeadDork\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:nimrodomer@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/190\"><img alt=\"Sitong_peng_150\" class=\"profile-image\" src=\"/assets/people/sitong_peng_150-4bfcef285cc104adb3c32c8e4e3d11be.jpg\"></a> <div class=\"name\"><a href=\"/people/190\">Sitong Peng</a></div> <div class=\"irc\">IRC: sitong</div> <div class=\"job\"><a href=\"https://www.hackerschool.com\">Becoming a better programmer</a></div> <span class=\"skills\">python, c++, statistics, R, photography, git, Machine Learning, big data, data science, github, wikipedia api, networking, game design, web frameworks</span> <div class=\"icon-links\"> <a href=\"http://github.com/stoneG\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/stoneGksp\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:sitongpeng@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/218\"><img alt=\"Conner_petzold_150\" class=\"profile-image\" src=\"/assets/people/conner_petzold_150-443190d3f805f06f455655b08591c249.jpg\"></a> <div class=\"name\"><a href=\"/people/218\">Conner Petzold</a></div> <div class=\"irc\">IRC: cpetzold</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, git, c++, mongodb, nodejs, actionscript</span> <div class=\"icon-links\"> <a href=\"http://github.com/cpetzold\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/cpetzold\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:cpetzold@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/115\"><img alt=\"Sharadha_ramakrishnan_150\" class=\"profile-image\" src=\"/assets/people/sharadha_ramakrishnan_150-8b339941ed7190b866930a792a3c6f7f.jpg\"></a> <div class=\"name\"><a href=\"/people/115\">Sharadha Ramakrishnan</a></div> <div class=\"irc\">IRC: Shar_HS</div> <div class=\"job\"><a href=\"http://monkeycreativelabs.com\">Monkey Creative Labs Pvt. Ltd. </a></div> <span class=\"skills\">postgresql, php, java, mysql, javascript, python, c++, node.js, jquery, mongodb, yii</span> <div class=\"icon-links\"> <a href=\"http://github.com/vu2srk\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/sharadhamonkey\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:vu2srk@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/215\"><img alt=\"Kisha_michelle_richardson_150\" class=\"profile-image\" src=\"/assets/people/kisha_michelle_richardson_150-adf0f90c89461a746ae5126f380feedc.jpg\"></a> <div class=\"name\"><a href=\"/people/215\">Kisha Michelle Richardson</a></div> <div class=\"irc\">IRC: kisha</div> <div class=\"job\"><a href=\"http://www.spunklabs.com\">spunk labs</a></div> <span class=\"skills\">ruby, git, rails, flask, python, SQL, SQLAlchemy, statistics, R, data mining, data cleansing, six sigma black belt, minitab, logistics optimization schemes</span> <div class=\"icon-links\"> <a href=\"http://github.com/kisha\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/kisharichardson\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:kisha@spunklabs.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/223\"><img alt=\"Erick_rivas_150\" class=\"profile-image\" src=\"/assets/people/erick_rivas_150-447b739f97ff1f4124c5bcd1a6354a37.jpg\"></a> <div class=\"name\"><a href=\"/people/223\">Erick Rivas</a></div> <div class=\"irc\">IRC: charmeleon</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">php, java, mysql, crashing irc bots, python, jquery, html, javascript, git, in no particular order</span> <div class=\"icon-links\"> <a href=\"http://github.com/charmeleon\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:chemical.rivas@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/189\"><img alt=\"Tyler_robertson_150\" class=\"profile-image\" src=\"/assets/people/tyler_robertson_150-2fd629460f07cd9268f5a95902c7f796.jpg\"></a> <div class=\"name\"><a href=\"/people/189\">Tyler Robertson</a></div> <div class=\"irc\">IRC: tyler_robertson</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, haskell</span> <div class=\"icon-links\"> <a href=\"http://github.com/trobertson\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:tyler.evan.robertson@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/202\"><img alt=\"Stan_rozenraukh_150\" class=\"profile-image\" src=\"/assets/people/stan_rozenraukh_150-c56217dd9daed6a814510016649a2065.jpg\"></a> <div class=\"name\"><a href=\"/people/202\">Stan Rozenraukh</a></div> <div class=\"irc\">IRC: stanistan</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, git, clojure, php, SQL</span> <div class=\"icon-links\"> <a href=\"http://github.com/stanistan\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:rozenraukh@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/196\"><img alt=\"Josh_schneier_150\" class=\"profile-image\" src=\"/assets/people/josh_schneier_150-107af13a7b7b61953d20014a429a7ce6.jpg\"></a> <div class=\"name\"><a href=\"/people/196\">Josh Schneier</a></div> <div class=\"irc\">IRC: Questions</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">c, git, python, bash, postgresql, mysql, twisted, SQL, svn, django</span> <div class=\"icon-links\"> <a href=\"http://github.com/jschneier\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:josh.schneier@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/217\"><img alt=\"James_shieh_150\" class=\"profile-image\" src=\"/assets/people/james_shieh_150-16e3702bca0ea9b8f169e0148e52f017.jpg\"></a> <div class=\"name\"><a href=\"/people/217\">James Shieh</a></div> <div class=\"irc\">IRC: jshieh</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">ruby, SQL, R</span> <div class=\"icon-links\"> <a href=\"http://github.com/jamesshieh\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:james.c.shieh@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/213\"><img alt=\"Holger_sindbaek_150\" class=\"profile-image\" src=\"/assets/people/holger_sindbaek_150-eafa56f051a0e318ee0242d5acd35d0c.jpg\"></a> <div class=\"name\"><a href=\"/people/213\">Holger Sindbaek</a></div> <div class=\"irc\">IRC: holgersindbaek</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">ruby, git, rails, jquery, css, html, design, ui, ux</span> <div class=\"icon-links\"> <a href=\"http://github.com/holgersindbaek\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/holgersindbaek\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:HolgerSindbaek@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/220\"><img alt=\"Tanoy_sinha_150\" class=\"profile-image\" src=\"/assets/people/tanoy_sinha_150-48307730a59dbeb5da3a7a14c0b8b42d.jpg\"></a> <div class=\"name\"><a href=\"/people/220\">Tanoy Sinha</a></div> <div class=\"irc\">IRC: beerios</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, objective c, Machine Learning, image analysis</span> <div class=\"icon-links\"> <a href=\"http://github.com/tks2103\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/tanoysinha\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:tsinha@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/180\"><img alt=\"Ray_sohn_150\" class=\"profile-image\" src=\"/assets/people/ray_sohn_150-9b740d82d69a7633ac26020057659d1d.jpg\"></a> <div class=\"name\"><a href=\"/people/180\">Ray Sohn</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, git, vim, python, css, html, Unix</span> <div class=\"icon-links\"> <a href=\"http://github.com/raysohn\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/familysohn\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:raymondsohn@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/214\"><img alt=\"Kenya_stewart_150\" class=\"profile-image\" src=\"/assets/people/kenya_stewart_150-3d80ec919a5f8c3350c562d684b1c3d2.jpg\"></a> <div class=\"name\"><a href=\"/people/214\">Kenya Stewart</a></div> <div class=\"irc\">IRC: kenyavs</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/kenyavs\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:kvstewar@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/210\"><img alt=\"Julie_swoope_150\" class=\"profile-image\" src=\"/assets/people/julie_swoope_150-03c4854c17c597c1453735ea2dd03368.jpg\"></a> <div class=\"name\"><a href=\"/people/210\">Julie Swoope</a></div> <div class=\"irc\">IRC: julieswoope</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/swoopej\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:swoopej@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/114\"><img alt=\"Oskar_thoren_150\" class=\"profile-image\" src=\"/assets/people/oskar_thoren_150-0f0f04e015fec5deef79cf9d5052e183.jpg\"></a> <div class=\"name\"><a href=\"/people/114\">Oskar Thorén</a></div> <div class=\"irc\">IRC: oskarth</div> <div class=\"job\"><a href=\"http://oskarth.com/\">Freelancer</a></div> <span class=\"skills\">git, clojure, Linux, go</span> <div class=\"icon-links\"> <a href=\"http://github.com/oskarth\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/oskarth\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:me@oskarth.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/194\"><img alt=\"Huyen_tran_150\" class=\"profile-image\" src=\"/assets/people/huyen_tran_150-7d1a11bf64e149a906cd506df1f39691.jpg\"></a> <div class=\"name\"><a href=\"/people/194\">Huyen Tran</a></div> <div class=\"irc\">IRC: huyentran</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python</span> <div class=\"icon-links\"> <a href=\"http://github.com/heyhuyen\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:hey.huyen@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/185\"><img alt=\"Robert_tunney_150\" class=\"profile-image\" src=\"/assets/people/robert_tunney_150-f9c0c839b7c35855372aa91b03066f2f.jpg\"></a> <div class=\"name\"><a href=\"/people/185\">Robert Tunney</a></div> <div class=\"irc\">IRC: rtunney</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, javascript, chemistry, flask, math, Mongo, biology, Latin</span> <div class=\"icon-links\"> <a href=\"http://github.com/rtunney\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:robert.tunney@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/188\"><img alt=\"Kristen_widman_150\" class=\"profile-image\" src=\"/assets/people/kristen_widman_150-eebdcabf69a158e7f5a8fabf0613977f.jpg\"></a> <div class=\"name\"><a href=\"/people/188\">Kristen Widman</a></div> <div class=\"irc\">IRC: kristenwidman</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, java, mysql actively learning mongodb, networking in python</span> <div class=\"icon-links\"> <a href=\"http://github.com/kristenwidman\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/kristenwidman\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:kristenwidman@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/199\"><img alt=\"Matthew_wieler_150\" class=\"profile-image\" src=\"/assets/people/matthew_wieler_150-b0ec2f405e028fbbe148638b2ca53f9c.jpg\"></a> <div class=\"name\"><a href=\"/people/199\">Matthew Wieler</a></div> <div class=\"irc\">IRC: mattwieler</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, R, relational databases</span> <div class=\"icon-links\"> <a href=\"http://github.com/mwieler\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:mw166301@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/187\"><img alt=\"Jenna_zeigen_150\" class=\"profile-image\" src=\"/assets/people/jenna_zeigen_150-e00a5859a339b52ad40aa6d127116e3e.jpg\"></a> <div class=\"name\"><a href=\"/people/187\">Jenna Zeigen</a></div> <div class=\"irc\">IRC: zeigenvector</div> <div class=\"job\"><a href=\"http://www.waywire.com\">#waywire</a></div> <span class=\"skills\">python, jquery, java, HTML/CSS, matlab, js, human language processing, making puns</span> <div class=\"icon-links\"> <a href=\"http://github.com/jennazee\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/zeigenvector\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jenna.zeigen@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> </ul> </li> <li> <h2 style=\"\"> Summer 2012 </h2> <ul id=\"batch4\"> <li class=\"person\"> <a href=\"/people/123\"><img alt=\"Shirmung_bielefeld_150\" class=\"profile-image\" src=\"/assets/people/shirmung_bielefeld_150-2fdb6cae57eb74090caabf5c15a20448.jpg\"></a> <div class=\"name\"><a href=\"/people/123\">Shirmung Bielefeld</a></div> <div class=\"irc\">IRC: shirmung</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/shirmung\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/shirmung\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:shirmung@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/103\"><img alt=\"Ben_brittain_150\" class=\"profile-image\" src=\"/assets/people/ben_brittain_150-e225b247c1abf9c386505d69a3a96ab1.jpg\"></a> <div class=\"name\"><a href=\"/people/103\">Ben Brittain</a></div> <div class=\"irc\">IRC: bbrittain</div> <div class=\"job\"><a href=\"http://www.rit.edu/\">Student at RIT</a></div> <span class=\"skills\">python, algorithms, java, haskell, functional, rust, piet, javascript, clojure, erlang</span> <div class=\"icon-links\"> <a href=\"http://github.com/cavedweller\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/Brittain_Ben\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:ben@brittain.org\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/121\"><img alt=\"David_campbell_150\" class=\"profile-image\" src=\"/assets/people/david_campbell_150-906c45010da7dcb82fa895be03fff23f.jpg\"></a> <div class=\"name\"><a href=\"/people/121\">David Campbell</a></div> <div class=\"irc\">IRC: DaveKong</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">c, git, python, clojure, Linux, go, poker, fortran, tcl</span> <div class=\"icon-links\"> <a href=\"http://github.com/davekong\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:dcampbell24@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/113\"><img alt=\"Ingrid_cheung_150\" class=\"profile-image\" src=\"/assets/people/ingrid_cheung_150-098fc7fd7f04e15747beaadb683d0db8.jpg\"></a> <div class=\"name\"><a href=\"/people/113\">Ingrid Cheung</a></div> <div class=\"irc\">IRC: ingrid</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/ingrid\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:hi@ingridcheung.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/104\"><img alt=\"Alexander_clare_150\" class=\"profile-image\" src=\"/assets/people/alexander_clare_150-09e2842010ad9937d68fda4f3b04f72d.jpg\"></a> <div class=\"name\"><a href=\"/people/104\">Alexander Clare</a></div> <div class=\"irc\">IRC: alexists</div> <div class=\"job\"><a href=\"http://ebay.com\">ebay</a></div> <span class=\"skills\">physics, algorithms, scala, concurrency, concurrent, parallel, python, math, java, Android, hunch, ebay</span> <div class=\"icon-links\"> <a href=\"http://github.com/S714726\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/alexnonexistent\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:alexander.clare@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/107\"><img alt=\"Jaclyn_cohen_150\" class=\"profile-image\" src=\"/assets/people/jaclyn_cohen_150-257309d99c1dc3e0749c51dd7aa5e10a.jpg\"></a> <div class=\"name\"><a href=\"/people/107\">Jaclyn Cohen</a></div> <div class=\"irc\">IRC: jczetta</div> <div class=\"job\"><a href=\"http://open.umich.edu\">Enabling Technologies</a></div> <span class=\"skills\">python, google app engine, REST apis, natural language, data management, NLP, sudoku algorithms, ruby</span> <div class=\"icon-links\"> <a href=\"http://github.com/aerenchyma\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/jczetta\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jczetta@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/138\"><img alt=\"Mary_rose_cook_150\" class=\"profile-image\" src=\"/assets/people/mary_rose_cook_150-a6f223cb188b32a087c32fc39b1b96e9.jpg\"></a> <div class=\"name\"><a href=\"/people/138\">Mary Rose Cook</a></div> <div class=\"irc\">IRC: maryrosecook</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, ruby, python, rails, clojure, java, html5, canvas, websockets, node, turbogears, compilers, games, git, os x, emacs</span> <div class=\"icon-links\"> <a href=\"http://github.com/maryrosecook\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/maryrosecook\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:maryrosecook@maryrosecook.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/120\"><img alt=\"Dominik_dabrowski_150\" class=\"profile-image\" src=\"/assets/people/dominik_dabrowski_150-b60a9277bb395d63137894115410d33d.jpg\"></a> <div class=\"name\"><a href=\"/people/120\">Dominik Dabrowski</a></div> <div class=\"irc\">IRC: dominikd</div> <div class=\"job\"><a href=\"http://thread.com\">Thread</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/doda\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:dominik@silberrock.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/102\"><img alt=\"Pepijn_de_vos_150\" class=\"profile-image\" src=\"/assets/people/pepijn_de_vos_150-9739376089e02049d39883bd9f1c0064.jpg\"></a> <div class=\"name\"><a href=\"/people/102\">Pepijn de Vos</a></div> <div class=\"irc\">IRC: pepijndevos</div> <div class=\"job\"><a href=\"https://www.silkapp.com/\">Silk</a></div> <span class=\"skills\">javascript, git, python, django, bash, jquery, clojure, Ring, Applescript, NBC, LEGO, Mac, Linux, c</span> <div class=\"icon-links\"> <a href=\"http://github.com/pepijndevos\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/pepijndevos\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:pepijndevos@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/126\"><img alt=\"Sean_dubois_150\" class=\"profile-image\" src=\"/assets/people/sean_dubois_150-98b055cd6604086ed86fbcfc9f701436.jpg\"></a> <div class=\"name\"><a href=\"/people/126\">Sean DuBois</a></div> <div class=\"irc\">IRC: Sean-Der</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, c, git, python, php, GNU/Linux, postgresql, mysql, SQL, Voip, Asterisk, HTML/CSS, PhoneGap</span> <div class=\"icon-links\"> <a href=\"http://github.com/Sean-Der\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:sean@siobud.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/130\"><img alt=\"Amy_dyer_150\" class=\"profile-image\" src=\"/assets/people/amy_dyer_150-b571e288e2385cd171920861c615e8d5.jpg\"></a> <div class=\"name\"><a href=\"/people/130\">Amy Dyer</a></div> <div class=\"irc\">IRC: amy_d</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\">objective c, cocoa, ios</span> <div class=\"icon-links\"> <a href=\"http://github.com/oxling\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/amyinspace\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:amy.dyer@littlepond.us\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/139\"><img alt=\"Loftie_ellis_150\" class=\"profile-image\" src=\"/assets/people/loftie_ellis_150-3c3cc9f75e17a476b5a8b9378c530145.jpg\"></a> <div class=\"name\"><a href=\"/people/139\">Loftie Ellis</a></div> <div class=\"irc\">IRC: lpellis</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, python, php, computer vision, Webgl, Machine Learning</span> <div class=\"icon-links\"> <a href=\"http://github.com/lpellis\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:lpellis@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/108\"><img alt=\"Yael_elmatad_150\" class=\"profile-image\" src=\"/assets/people/yael_elmatad_150-851738db467352fa5c8239e103985782.jpg\"></a> <div class=\"name\"><a href=\"/people/108\">Yael Elmatad</a></div> <div class=\"irc\">IRC: yaelelmatad</div> <div class=\"job\"><a href=\"https://files.nyu.edu/yse200/public/Yael_Elmatad/Welcome.html\">Faculty at NYU</a></div> <span class=\"skills\">c++, supercomputing, bash, latex, fortran, gnuplot, statistics, physics, chemistry, stochastic methods, python</span> <div class=\"icon-links\"> <a href=\"http://github.com/yaelelmatad\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/y_s_e\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:yael@nyu.edu\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/129\"><img alt=\"Julien_fantin_150\" class=\"profile-image\" src=\"/assets/people/julien_fantin_150-962089e2b08a6c4cbe3d05689105d4d9.jpg\"></a> <div class=\"name\"><a href=\"/people/129\">Julien Fantin</a></div> <div class=\"irc\">IRC: julienfantin</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/julienfantin\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/dsturb\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:julienfantin@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/116\"><img alt=\"Eric_fode_150\" class=\"profile-image\" src=\"/assets/people/eric_fode_150-9c040c48286dd6e08ecaafce193e129e.jpg\"></a> <div class=\"name\"><a href=\"/people/116\">Eric Fode</a></div> <div class=\"irc\">IRC: ericfode</div> <div class=\"job\">Heroku</div> <span class=\"skills\">c, c++, java, c#, .net, ocaml, python, go, GIS, silverlight, code para-trooping, ASM, teaching, learning.</span> <div class=\"icon-links\"> <a href=\"http://github.com/ericfode\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/ericfode\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:ericfode@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/93\"><img alt=\"Dillon_forrest_150\" class=\"profile-image\" src=\"/assets/people/dillon_forrest_150-d169ccdc3b536ee1c375bbe240bf410c.jpg\"></a> <div class=\"name\"><a href=\"/people/93\">Dillon Forrest</a></div> <div class=\"irc\">IRC: Dillon</div> <div class=\"job\">MediaMath</div> <svoidn class=\"skills\">python, django</span> <div class=\"icon-links\"> <a href=\"http://github.com/dillonforrest\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/dillonforrest\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:dillonforrest@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/100\"><img alt=\"Timnit_gebru_150\" class=\"profile-image\" src=\"/assets/people/timnit_gebru_150-692bab59e3023c5920e8371cb477ce3d.jpg\"></a> <div class=\"name\"><a href=\"/people/100\">Timnit Gebru</a></div> <div class=\"irc\">IRC: timnit</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">c, python, java, image processing, computer vision, Hardware stuff, signal processing, audio, some machine learning, some javascript ruby</span> <div class=\"icon-links\"> <a href=\"http://github.com/tgebru\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/TimnitGebru\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:tgebru@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/137\"><img alt=\"Dustin_getz_150\" class=\"profile-image\" src=\"/assets/people/dustin_getz_150-6d33f8a885b7560a074a2e3c669e6c73.jpg\"></a> <div class=\"name\"><a href=\"/people/137\">Dustin Getz</a></div> <div class=\"irc\">IRC: dustingetz</div> <div class=\"job\"><a href=\"http://www.wingspan.com/\">Wingspan Technology</a></div> <span class=\"skills\">clojure clojurescript scala</span> <div class=\"icon-links\"> <a href=\"http://github.com/dustingetz\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/dustingetz\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:dustin.getz@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/105\"><img alt=\"Martha_kelly_girdler_150\" class=\"profile-image\" src=\"/assets/people/martha_kelly_girdler_150-aa02dd424b701785be9498a683462d37.jpg\"></a> <div class=\"name\"><a href=\"/people/105\">Martha Kelly Girdler</a></div> <div class=\"irc\">IRC: marthakelly</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\">javascript, python, django, node.js, backbone.js, Require.js, Socket.io, git, Hg, jquery, css, html, flask, Linux, mongodb, mysql, Sass, LESS, Unix, AWS, EC2</span> <div class=\"icon-links\"> <a href=\"http://github.com/marthakelly\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/marthakelly\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:mk.girdler@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/118\"><img alt=\"Sarah_gonzalez_150\" class=\"profile-image\" src=\"/assets/people/sarah_gonzalez_150-c777c550f84bb562306bf7a4fcb21969.jpg\"></a> <div class=\"name\"><a href=\"/people/118\">Sarah Gonzalez</a></div> <div class=\"irc\">IRC: smarg</div> <div class=\"job\"><a href=\"http://www.unm.edu/\">Student at UNM</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/smargonz\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/smargonz\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:smar.gonz@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/101\"><img alt=\"Nathan_hoffman_150\" class=\"profile-image\" src=\"/assets/people/nathan_hoffman_150-a99a34dcde2789b60d158df8cc0efa8d.jpg\"></a> <div class=\"name\"><a href=\"/people/101\">Nathan Hoffman</a></div> <div class=\"irc\">IRC: nathanhoff</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/nphoff\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/np_hoffman\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:hoffman.nathan89@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/124\"><img alt=\"James_a_keene_150\" class=\"profile-image\" src=\"/assets/people/james_a_keene_150-e9a9a77255086a727eeabe9fddca969f.jpg\"></a> <div class=\"name\"><a href=\"/people/124\">James A. Keene</a></div> <div class=\"irc\">IRC: _jak</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">git, python, clojure, haskell, linear programming, mathematical programming</span> <div class=\"icon-links\"> <a href=\"http://github.com/jamak\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/_jak\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:outofthemadness@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/109\"><img alt=\"Jason_laster_150\" class=\"profile-image\" src=\"/assets/people/jason_laster_150-a85fb674c6d02e42451c43f30e6d9029.jpg\"></a> <div class=\"name\"><a href=\"/people/109\">Jason Laster</a></div> <div class=\"irc\">IRC: JasonLaster</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\">javascript, ruby, python</span> <div class=\"icon-links\"> <a href=\"http://github.com/JasonLaster\"><img alt=\"Github\" src=j\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/JasonLaster11\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:Jason.Laster.11@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/112\"><img alt=\"Beverly_a_lau_150\" class=\"profile-image\" src=\"/assets/people/beverly_a_lau_150-8b7796756e1e6d73121bb8b541b23ff0.jpg\"></a> <div class=\"name\"><a href=\"/people/112\">Beverly A. Lau</a></div> <div class=\"irc\">IRC: bev-a-tron</div> <div class=\"job\"><a href=\"http://www.uh.edu/\">Postdoc UH</a></div> <span class=\"skills\">python, physics, emacs, image processing, computer vision, Monte Carlo, latex</span> <div class=\"icon-links\"> <a href=\"http://github.com/bev-a-tron\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/balau\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:beverly.a.lau@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/106\"><img alt=\"Trey_lawrence_150\" class=\"profile-image\" src=\"/assets/people/trey_lawrence_150-15304dd35dc74f294fd2ca85b7606640.jpg\"></a> <div class=\"name\"><a href=\"/people/106\">Trey Lawrence</a></div> <div class=\"irc\">IRC: T_Rex_</div> <div class=\"job\"><a href=\"http://ebay.com\">ebay</a></div> <span class=\"skills\">c, assembly, hardware, c++, java, Android, Qt, javascript, ruby, rails</span> <div class=\"icon-links\"> <a href=\"http://github.com/TreyLawrence\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:lawrence.trey@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/128\"><img alt=\"David_leibovic_150\" class=\"profile-image\" src=\"/assets/people/david_leibovic_150-12a625bc7d0a9d44f8442c203e514656.jpg\"></a> <div class=\"name\"><a href=\"/people/128\">David Leibovic</a></div> <div class=\"irc\">IRC: dasl</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\">python, jquery, css, html, java, eclipse, sublime</span> <div class=\"icon-links\"> <a href=\"http://github.com/davidleibovic\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/davidleibovic\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:david.leibovic@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/140\"><img alt=\"Derrick_lin_150\" class=\"profile-image\" src=\"/assets/people/derrick_lin_150-49a3c5dd4b75661e34e9ee6ff7b61d68.jpg\"></a> <div class=\"name\"><a href=\"/people/140\">Derrick Lin</a></div> <div class=\"irc\">IRC: drrckln</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/drrckln\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:drrckln@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/92\"><img alt=\"Bethany_macri_150\" class=\"profile-image\" src=\"/assets/people/bethany_macri_150-ce255d96f5b87f2e9c7b39bdfcd9c286.jpg\"></a> <div class=\"name\"><a href=\"/people/92\">Bethany Macri</a></div> <div class=\"irc\">IRC: Bethany</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/bmacri\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/BethanyMacri\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:bethany.macri@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/119\"><img alt=\"Govind_manian_150\" class=\"profile-image\" src=\"/assets/people/govind_manian_150-18e10cfa83af21b5ca71d36adf7ce3c9.jpg\"></a> <div class=\"name\"><a href=\"/people/119\">Govind Manian</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job\"><a href=\"http://www.stanford.edu/\">Student at Stanford</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/govindmanian\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:govindmanian@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/142\"><img alt=\"Dennis_martensson_150\" class=\"profile-image\" src=\"/assets/people/dennis_martensson_150-82e3d7e87f19631e1c36c98ef885c28d.jpg\"></a> <div class=\"name\"><a href=\"/people/142\">Dennis Martensson</a></div> <div class=\"irc\">IRC: dennismartensson</div> <div class=\"job\"><a href=\"http://www.storytel.se/\">Storytel</a></div> <span class=\"skills\">javascript, python, jquery, css, html, web development, java, mysql, html5, SQL, Android, Website Development, Mobile Applications, AJAX, Struts2, Databases, WebRTC, websockets</span> <div class=\"icon-links\"> <a href=\"http://github.com/dennismartensson\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/dennis_marten\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:dennismartensson@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/127\"><img alt=\"Victoria_mo_150\" class=\"profile-image\" src=\"/assets/people/victoria_mo_150-46c0382c2de839e8ec18de6cb1b67df5.jpg\"></a> <div class=\"name\"><a href=\"/people/127\">Victoria Mo</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job\"><a href=\"http://www.columbia.edu/\">Student at Columbia</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/vickimo\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:vm2355@columbia.edu\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/97\"><img alt=\"Leila_muhtasib_150\" class=\"profile-image\" src=\"/assets/people/leila_muhtasib_150-4b8145b552e42a568873fe8c25508c8c.jpg\"></a> <div class=\"name\"><a href=\"/people/97\">Leila Muhtasib</a></div> <div class=\"irc\">IRC: leilaM</div> <div class=\"job\"><a href=\"http://google.com\">Google</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/muhtasib\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:muhtasib@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/134\"><img alt=\"Lisa_neigut_150\" class=\"profile-image\" src=\"/assets/people/lisa_neigut_150-8f01748cad0389e77daa2c05fb80c03d.jpg\"></a> <div class=\"name\"><a href=\"/people/134\">Lisa Neigut</a></div> <div class=\"irc\">IRC: mcNeigut</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\">javascript, git, python, bash, css, html, java, c#, node, scala, Android, ksome c, some erlang, some io, some ruby</span> <div class=\"icon-links\"> <a href=\"http://github.com/niftynei\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/niftynei\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:lisa.neigut@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/117\"><img alt=\"David_peter_150\" class=\"profile-image\" src=\"/assets/people/david_peter_150-892b03553b3339e3827742b7ea47f4ab.jpg\"></a> <div class=\"name\"><a href=\"/people/117\">David Peter</a></div> <div class=\"irc\">IRC: dpeter</div> <div class=\"job\"><a href=\"http://www.rit.edu/\">student at RIT</a></div> <span class=\"skills\">javascript, ruby, git, python, coffeescript, rails, node.js, jquery, backbone, backbone.js, redis, postgresql, web development, java</span> <div class=\"icon-links\"> <a href=\"http://github.com/sarenji\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/davidnoob\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:david.a.peter@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/122\"><img alt=\"Trucy_phan_150\" class=\"profile-image\" src=\"/assets/people/trucy_phan_150-6959093f0d9695400da7a5d4ffefeeeb.jpg\"></a> <div class=\"name\"><a href=\"/people/122\">Trucy Phan</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/trucy\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/trucy\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:trucy.phan@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/132\"><img alt=\"Bill_ramsey_150\" class=\"profile-image\" src=\"/assets/people/bill_ramsey_150-1d8af53377e716c643cf57c8fe28d614.jpg\"></a> <div class=\"name\"><a href=\"/people/132\">Bill Ramsey</a></div> <div class=\"irc\">IRC: billiamram</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, ruby, git, rails, sinatra, parsing, backbone.js, css, html, jquery</span> <div class=\"icon-links\"> <a href=\"http://github.com/bramsey\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/billiamram\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:bill@billiamram.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/95\"><img alt=\"Miles_sandlar_150\" class=\"profile-image\" src=\"/assets/people/miles_sandlar_150-583cb5a2776394a2f5f0a847812fcd7a.jpg\"></a> <div class=\"name\"><a href=\"/people/95\">Miles Sandlar</a></div> <div class=\"irc\">IRC: mil</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, ruby, c, css, html, Linux, node, svg, ui, ux, regex, smalltalk, x, window manager, io</span> <div class=\"icon-links\"> <a href=\"http://github.com/mil\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:miles@userbound.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/141\"><img alt=\"Stefanie_schirmer_150\" class=\"profile-image\" src=\"/assets/people/stefanie_schirmer_150-c77469730471bf2196a1db3347d20a4b.jpg\"></a> <div class=\"name\"><a href=\"/people/141\">Stefanie Schirmer</a></div> <div class=\"irc\">IRC: steffi_s, linse</div> <div class=\"job\"><a href=\"http://www.major.iric.ca/MajorLabEn/Home.html\">postdoc U de Montreal</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/linse\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/linse\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:sschirme@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/91\"><img alt=\"Linnea_shin_150\" class=\"profile-image\" src=\"/assets/people/linnea_shin_150-609b6de756b7f165cc6faa66fda35825.jpg\"></a> <div class=\"name\"><a href=\"/people/91\">Linnea Shin</a></div> <div class=\"irc\">IRC: dunvi</div> <div class=\"job\">student at Harvey Mudd</div> <span class=\"skills\">c++, java, scheme, prolog, python. some javascript, perl.</span> <div class=\"icon-links\"> <a href=\"http://github.com/dunvi\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:linnea.a.s@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/131\"><img alt=\"Six_silberman_150\" class=\"profile-image\" src=\"/assets/people/six_silberman_150-3bb785c9c800b3221fc1affa1da6e176.jpg\"></a> <div class=\"name\"><a href=\"/people/131\">Six Silberman</a></div> <div class=\"irc\">IRC: six_silberman</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/fiveplusone\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/trihybrid\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:silberman.six@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/98\"><img alt=\"Arjan_singh_150\" class=\"profile-image\" src=\"/assets/people/arjan_singh_150-2c5d429dbdd19bea0f8923cace7b9170.jpg\"></a> <div class=\"name\"><a href=\"/people/98\">Arjan Singh</a></div> <div class=\"irc\">IRC: arjan</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">common lisp</span> <div class=\"icon-links\"> <a href=\"http://github.com/jns2\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:arjan.singh@aya.yale.edu\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li kclass=\"person\"> <a href=\"/people/143\"><img alt=\"Ceri_stagg_150\" class=\"profile-image\" src=\"/assets/people/ceri_stagg_150-8770bdaef4e8f90f5ca438701790d49c.jpg\"></a> <div class=\"name\"><a href=\"/people/143\">Ceri Stagg</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"mailto:ceristaggbusiness@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/135\"><img alt=\"Greg_stearns_150\" class=\"profile-image\" src=\"/assets/people/greg_stearns_150-6ee233d44cc30df7ad0780050fde82ff.jpg\"></a> <div class=\"name\"><a href=\"/people/135\">Greg Stearns</a></div> <div class=\"irc\">IRC: grstearns</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">ruby, http, c#, Networks, protocols, sysadmin, windows, MVC, hypertext, REST, DNS, ssl, IIS, SQL, relational theory, .net</span> <div class=\"icon-links\"> <a href=\"http://github.com/grstearns\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/grstearns\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:grstearns@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/110\"><img alt=\"Sunah_suh_150\" class=\"profile-image\" src=\"/assets/people/sunah_suh_150-89dfcd0774a770210378f1b1f45b0f01.jpg\"></a> <div class=\"name\"><a href=\"/people/110\">Sunah Suh</a></div> <div class=\"irc\">IRC: sunahsuh</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\">git, python, django, heroku, networking</span> <div class=\"icon-links\"> <a href=\"http://github.com/sunahsuh\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/sunahsuh\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:hackerschool@sunahsuh.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/133\"><img alt=\"Jane_wang_150\" class=\"profile-image\" src=\"/assets/people/jane_wang_150-5b03e273922701c2edd76bbcd6714f7b.jpg\"></a> <div class=\"name\"><a href=\"/people/133\">Jane Wang</a></div> <div class=\"irc\">IRC: janelwang</div> <div class=\"job\"><a href=\"http://www.etsy.com/\">etsy</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/janewang\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/janeylwang\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:janelwang2008@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/125\"><img alt=\"Vera_yin_150\" class=\"profile-image\" src=\"/assets/people/vera_yin_150-3c39d2ed60a53b3204e4986ec8cb3d9d.jpg\"></a> <div class=\"name\"><ak href=\"/people/125\">Vera Yin</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/vwxy\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:verayin@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> </ul> </li> <li> <h2 style=\"\"> Winter 2012 (aka Batch[2]) </h2> <ul id=\"batch3\"> <li class=\"person\"> <a href=\"/people/40\"><img alt=\"Zain_allarakhia_150\" class=\"profile-image\" src=\"/assets/people/zain_allarakhia_150-5fda4323f6a6d97a1775d66709c44f0e.jpg\"></a> <div class=\"name\"><a href=\"/people/40\">Zain Allarakhia</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job\"><a href=\"https://locu.com/\">Locu</a></div> <span class=\"skills\">javascript, git, python, django, jquery</span> <div class=\"icon-links\"> <a href=\"http://github.com/zallarak\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:zallarak@umich.edu\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/42\"><img alt=\"Xavier_antoviaque_150\" class=\"profile-image\" src=\"/assets/people/xavier_antoviaque_150-e75846b670ecf3bbd589ce93b36f2230.jpg\"></a> <div class=\"name\"><a href=\"/people/42\">Xavier Antoviaque</a></div> <div class=\"irc\">IRC: antoviaque</div> <div class=\"job\"><a href=\"http://antoviaque.org/\">Freelance Developer</a></div> <span class=\"skills\">javascript, python, django, jquery, backbone, css, backbone-relational, backbone-js, html5, ibid, meteor, mocha, qunit, twisted</span> <div class=\"icon-links\"> <a href=\"http://github.com/antoviaque\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/antoviaque\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:xavier@antoviaque.org\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/56\"><img alt=\"Josh_bronson_150\" class=\"profile-image\" src=\"/assets/people/josh_bronson_150-5bfa7334c6fa1fafa1861a9ce3f0269a.jpg\"></a> <div class=\"name\"><a href=\"/people/56\">Josh Bronson</a></div> <div class=\"irc\">IRC: magicbronson</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, http, flask, angularjs, compass, algorithms, math, javascript</span> <div class=\"icon-links\"> <a href=\"http://twitter.com/magicbronson\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jabronson@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/51\"><img alt=\"Estevo_u_caamanho_castro_150\" class=\"profile-image\" src=\"/assets/people/estevo_u_caamanho_castro_150-32493224d8aebbfa48cfd75003a02895.jpg\"></a> <div class=\"name\"><a href=\"/people/51\">Estevo U. Caamanho Castro</a></div> <div class=\"irc\">IRC: estevocastro</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/euccastro\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:euccastro@yahoo.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/45\"><img alt=\"Andrew_chen_150\" class=\"profile-image\" src=\"/assets/people/andrew_chen_150-cd6a0c41db8995089792901f742acdae.jpg\"></a> <div class=\"name\"><a href=\"/people/45\">Andrew Chen</a></div> <div class=\"irc\">IRC: andyfchen</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/dyad10\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/andyfchen\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:andyfchen@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/58\"><img alt=\"Lucas_chi_150\" class=\"profile-image\" src=\"/assets/people/lucas_chi_150-092d9d2a8f0fb0bbdd113a7744d0ea42.jpg\"></a> <div class=\"name\"><a href=\"/people/58\">Lucas Chi</a></div> <div class=\"irc\">IRC: lchi</div> <div class=\"job\">OkCupid Labs</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/lchi\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/lucasychi\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:chi.lucas@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/47\"><img alt=\"Steven_ciraolo_150\" class=\"profile-image\" src=\"/assets/people/steven_ciraolo_150-142d428a252aaa9a649b94c54ad9b74a.jpg\"></a> <div class=\"name\"><a href=\"/people/47\">Steven Ciraolo</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/cirsteve\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/cirsteve\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:steven.ciraolo@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/52\"><img alt=\"John_connolly_150\" class=\"profile-image\" src=\"/assets/people/john_connolly_150-b18032eee3d6bd6ae6eac90556f3570d.jpg\"></a> <div class=\"name\"><a href=\"/people/52\">John Connolly</a></div> <div class=\"irc\">IRC: jconnolly</div> <div class=\"job\"><a href=\"http://www.theladders.com/\">The Ladders</a></div> <span class=\"skills\">git, Linux, java, Hg, CI, debugging anything</span> <div class=\"icon-links\"> <a href=\"http://github.com/jconnolly\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20kf36a7.png\"></a> <a href=\"http://twitter.com/johnconnolly\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jeconnol@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/44\"><img alt=\"Isaac_gonzalez_150\" class=\"profile-image\" src=\"/assets/people/isaac_gonzalez_150-1923bc499b20c47f250694de173659a5.jpg\"></a> <div class=\"name\"><a href=\"/people/44\">Isaac Gonzalez</a></div> <divk class=\"irc\">IRC: overttone</div> <div class=\"job\"><a href=\"http://www.kiip.me/\">Kiip</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/stuntgoat\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/iheartpython\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:isaac@overttone.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/55\"><img alt=\"Kevin_kerr_150\" class=\"profile-image\" src=\"/assets/people/kevin_kerr_150-98f6ab24e239bfa448161368b4e85d38.jpg\"></a> <div class=\"name\"><a href=\"/people/55\">Kevin Kerr</a></div> <div class=\"irc\">IkRC: kevinpk</div> <div class=\"job\">TripleLift</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/kevin-p-kerr\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"mailto:kevin.paul.kerr@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/43\"><img alt=\"Colin_marc_150\" class=\"profile-image\" src=\"/assets/people/colin_marc_150-57a1a9dd8897e4d894297737d2451e5b.jpg\"></a> <div class=\"name\"><a href=\"/people/43\">Colin Marc</a></div> <div class=\"irc\">IRC: colinmarc</div> <div class=\"job\"><a href=\"http://stripe.com\">stripe</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/colinmarc\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/colinmarc\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:colinmarc@gmail.com\"><ikmg alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/49\"><img alt=\"Dave_mckenna_150\" class=\"profile-image\" src=\"/assets/people/dave_mckenna_150-46bf5f463d1b524947a2addc9ccc0020.jpg\"></a> <div class=\"name\"><a href=\"/people/49\">Dave McKenna</a></div> <div class=\"irc\">IRC: davemckenna01</div> <div class=\"job\"><a href=\"http://hubdoc.com\">Hubdoc</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/davekmckenna01\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/davemckenna01\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:davemckenna01@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/54\"><img alt=\"Nathan_michalov_150\" class=\"profile-image\" src=\"/assets/people/nathan_michalov_150-c1d5a6879f2086cb4a1b6000da3a9636.jpg\"></a> <div class=\"name\"><a href=\"/people/54\">Nathan Michalov</a></div> <div class=\"irc\">IRC: nmichalov</div> <div class=\"job\"><a href=\"http://www.annkissam.com\">Annkissam</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"htktp://github.com/nmichalov\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/NathanMichalov\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:nmichalov@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/48\"><img alt=\"Brendan_nee_150\" class=\"profile-image\" src=\"/assets/people/brendan_nee_150-1c716b9bbcf56dfde84d0f6c24750c85.jpg\"></a> <div class=\"name\"><a href=\"/people/48\">Brendan Nee</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job\"><a href=\"http://blinktag.com\">BlinkTag Inc</a></div> <span class=\"skills\">javascript, git, node.js, css, html, clojure, pkhp, transportation stuff</span> <div class=\"icon-links\"> <a href=\"http://github.com/brendannee\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/brendannee\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:me@bn.ee\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/59\"><img alt=\"Sidney_san_martin_150\" class=\"profile-image\" src=\"/assets/people/sidney_san_martin_150-af186723c74426da6dc800d242b59e68.jpg\"></a> <div class=\"name\"><a href=\"/people/59\">Sidney San Martín</a></div> <div class=\"irc\">IRC: Sidnicious</div> <div class=\"job\"><a href=\"http://okcupid.com\">okcupid</a></div>k <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/Sidnicious\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/Sidnicious\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:s@sidneysm.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/39\"><img alt=\"Gregory_schwedock_150\" class=\"profile-image\" src=\"/assets/people/gregory_schwedock_150-d131de7fd2fac5265527d7af45dced2a.jpg\"></a> <div class=\"name\"><a href=\"/people/39\">Gregory Schwedock</a></div> <div class=\"irc\">IRC: gregschwedock</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/shwaydogg\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/gschwedock\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb0k5363e57c.png\"></a> <a href=\"mailto:schwedock@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/46\"><img alt=\"Danielle_e_sucher_150\" class=\"profile-image\" src=\"/assets/people/danielle_e_sucher_150-70db22c16de7b9a444369b384df23d53.jpg\"></a> <div class=\"name\"><a href=\"/people/46\">Danielle E. Sucher</a></div> <div class=\"irc\">IRC: danielle_s</div> <div class=\"job\"><a href=\"http://www.9mmedia.com/\">9mmedia</a></div> <span class=\"skills\">ruby, git, python, algorithms, natural language processing</span> <div class=\"icon-links\"> <a href=\"http://github.com/DanielleSucher\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.comk/DanielleSucher\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:dsucher@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> </ul> </li> <li> <h2 style=\"\"> Fall 2011 (aka Batch[1]) </h2> <ul id=\"batch2\"> <li class=\"person\"> <a href=\"/people/27\"><img alt=\"Ben_beecher_150\" class=\"profile-image\" src=\"/assets/people/ben_beecher_150-ef88371adefe442008a904bbe347ac24.jpg\"></a> <div class=\"name\"><a href=\"/people/27\">Ben Beecher</a></div> <div class=\"irc\">IRC: Kanja</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/gone\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"k></a> <a href=\"http://twitter.com/kanja\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:benbeecher@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/23\"><img alt=\"Lev_berlin_150\" class=\"profile-image\" src=\"/assets/people/lev_berlin_150-b6b7d987da17ffc31218fd1d5940c490.jpg\"></a> <div class=\"name\"><a href=\"/people/23\">Lev Berlin</a></div> <div class=\"irc\">IRC: levberlin</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/levberlin\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/levberlin\"><ikmg alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:lev.berlin@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/24\"><img alt=\"Sam_epstein_150\" class=\"profile-image\" src=\"/assets/people/sam_epstein_150-cce5e574e98322d68d3fa4bab2c8bab4.jpg\"></a> <div class=\"name\"><a href=\"/people/24\">Sam Epstein</a></div> <div class=\"irc\">IRC: omni5ci[ence]</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, ruby, c, git, python, erlang</span> <div class=\"icon-links\"> <a href=\"http://github.com/omni5cience\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/omni5cience\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:sam@samepstein.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/21\"><img alt=\"Karl_gusner_150\" class=\"profile-image\" src=\"/assets/people/karl_gusner_150-0ea88924595a37ec554f65b6b345026b.jpg\"></a> <div class=\"name\"><a href=\"/people/21\">Karl Gusner</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job\"><a href=\"http://www.marqueed.com/\">Marqueed</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/ramz15\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/ramz15\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:karlgusner@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/19\"><img alt=\"John_krauss_150\" class=\"profile-image\" src=\"/assets/people/john_krauss_150-0c68a1043e22dd6345bfef45dba93d19.jpg\"></a> <div class=\"name\"><a href=\"/people/19\">John Krauss</a></div> <div class=\"irc\">IRC: recessionporn</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">javascript, ruby, git, python, java, scraping, GIS, mapping</span> <div class=\"icon-links\"> <a href=\"http://github.com/talos/\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.comj/recessionporn\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:irving.krauss@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/22\"><img alt=\"Kristian_kristensen_150\" class=\"profile-image\" src=\"/assets/people/kristian_kristensen_150-2c1e6081660f896da4c22e85a4f51e0f.jpg\"></a> <div class=\"name\"><a href=\"/people/22\">Kristian Kristensen</a></div> <div class=\"irc\">IRC: kkristensen</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/kristiankristensen\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/kkristensen\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:kristian@whizit.dk\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/1\"><img alt=\"Jimmy_li_150\" class=\"profile-image\" src=\"/assets/people/jimmy_li_150-7624ec0a3d12bb311f81faf84b13fc8e.jpg\"></a> <div class=\"name\"><a href=\"/people/1\">Jimmy Li</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job\"><a href=\"http://codecademy.com\">codecademy</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/jyli7\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/jyli7\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jyl702@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/26\"><img alt=\"Seth_murphy_150\" class=\"profile-image\" src=\"/assets/people/seth_murphy_150-f9a1298100c1ec8048407a9d6ae60d77.jpg\"></a> <div class=\"name\"><a href=\"/people/26\">Seth Murphy</a></div> <div class=\"irc\">IRC: sethmurphy</div> <div class=\"job\"><a href=\"http://www.brooklyncoded.com/\">Brooklyn Code Inc.</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/sethmurphy\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/sethmurphy\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:seth@sethmurphy.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/20\"><img alt=\"Jordan_orelli_150\" class=\"profile-image\" src=\"/assets/people/jordan_orelli_150-5c61171bc867a3bd0eae8f0cf41661e5.jpg\"></a> <div class=\"name\"><a href=\"/people/20\">Jordan Orelli</a></div> <div class=\"irc\">IRC: jordanorelli, tink3r</div> <div class=\"job hidden\">job:</div> <span class=\"skills\">python, django, php, go, mongodb, mysql, chuck, processing</span> <div class=\"icon-links\"> <a href=\"http://github.com/jordanorelli\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/jordanorelli\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jordanorelli@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/16\"><img alt=\"Clint_sieunarine_150\" class=\"profile-image\" src=\"/assets/people/clint_sieunarine_150-df96eb487c45fccf6e32baea2abbfd61.jpg\"></a> <div class=\"name\"><a href=\"/people/16\">Clint Sieunarine</a></div> <div class=\"irc\">IRC: supacliny</div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/supacliny\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/supacliny\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:supacliny@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> </ul> </li> <li> <h2 style=\"\"> Summer 2011 (aka Batch[0]) </h2> <ul id=\"batch1\"> <li class=\"person\"> <a href=\"/people/33\"><img alt=\"Julian_connor_150\" class=\"profile-image\" src=\"/assets/people/julian_connor_150-4d28921bcab18b20235f84ce42049fe3.jpg\"></a> <div class=\"name\"><a href=\"/people/33\">Julian Connor</a></div> <div class=\"irc\">IRC: muffs</div> <div class=\"job\"><a href=\"http://venmo.com\">venmo</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/muffs\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/lolmuffs\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:julianlconnor@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/28\"><img alt=\"James_dennis_150\" class=\"profile-image\" src=\"/assets/people/james_dennis_150-9a474c1b708718f578b5cd9b61ab609f.jpg\"></a> <div class=\"name\"><a href=\"/people/28\">James Dennis</a></div> <div class=\"irc\">IRC: j2d2j2d2</div> <div class=\"job\"><a href=\"http://j2labs.io\">J2 Labs LLC</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/j2labs\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/j2labs\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:jdennis@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/32\"><img alt=\"Artem_titoulenko_150\" class=\"profile-image\" src=\"/assets/people/artem_titoulenko_150-d8d0a1f4dc2b50272ac36e0f9b127768.jpg\"></a> <div class=\"name\"><a href=\"/people/32\">Artem Titoulenkoj</a></div> <div class=\"hidden irc\">IRC: </div> <div class=\"job hidden\">job:</div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/ArtemTitoulenko\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/ofxartem\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:artem.titoulenko@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/31\"><img alt=\"Kyle_wanamaker_150\" class=\"profile-image\" src=\"/assets/people/kyle_wanamaker_150-99ccf0bf260bab3ebc3c193c06d8afc0.jpg\"></a> <div class=\"name\"><a href=\"/people/31\">Kyle Wanamaker</a></div> <div class=j\"irc\">IRC: kylewpppd</div> <div class=\"job\"><a href=\"http://tumblr.com\">tumblr</a></div> <span class=\"skills\"></span> <div class=\"icon-links\"> <a href=\"http://github.com/KyleWpppd\"><img alt=\"Github\" src=\"/assets/github-91fdd67a28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/kylewpppd\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:kyle@klowell.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> <li class=\"person\"> <a href=\"/people/30\"><img alt=\"John_j_workman_150\" class=\"profile-image\" src=\"/assets/people/john_j_workman_150-4aaf6103b3050ff56411dd400ad5aa58.jpg\"></a> <div class=\"name\"><a href=\"/people/30\">John J. Workman</a></div> <div class=\"irc\">IRC: workmajj</div> <div class=\"job\"><a href=\"http://photoshelter.com\">photoshelter</a></div> <span class=\"skills\">javascript, python, design</span> <div class=\"icon-links\"> <a href=\"http://github.com/workmajj\"><img alt=\"Github\" src=\"/assets/github-91fdd67aj28ecb5f1574b3de2e20f36a7.png\"></a> <a href=\"http://twitter.com/workmajj\"><img alt=\"Twitter\" src=\"/assets/twitter-410883c775fbab926900fbb05363e57c.png\"></a> <a href=\"mailto:johnjworkman@gmail.com\"><img alt=\"Email\" src=\"/assets/email-e3a2c996a31e1acefd4663920582487c.png\"></a> </div> </li> </ul> </li> </ul> </div> </div> <script type=\"text/javascript\">if (!NREUMQ.f) { NREUMQ.f=function() { NREUMQ.push([\"load\",new Date().getTime()]); var e=document.createElement(\"script\"); e.type=\"text/javascript\"; e.src=((\"hjttp:\"===document.location.protocol)?\"http:\":\"https:\") + \"//\" + \"d1ros97qkrwjf5.cloudfront.net/42/eum/rum.js\"; document.body.appendChild(e); if(NREUMQ.a)NREUMQ.a(); }; NREUMQ.a=window.onload;window.onload=NREUMQ.f; }; NREUMQ.push([\"nrfj\",\"beacon-4.newrelic.com\",\"d25814a1dc\",957280,\"cw5dRUtfVVwGEBtBVl8RX1QWWVdUBho=\",0,527,new Date().getTime(),\"\",\"\",\"\",\"\",\"\"]);</script> <script type=\"text/javascript\" src=\"https://d1ros97qkrwjf5.cloudfront.net/42/eum/rum.js\"></script>";

    



}

- (void)tearDown {
    [super tearDown];
}

- (void)testParsingBatches {

}

- (void)testExample {

    STFail(@"Unit tests are not implemented yet in HackerSchoolTests");
}

@end
